opcode makeParentContainer, i[], i[]SSi
    iBBox[], SChan, SParent, iVisible xin

    x_create "image", fillarray(x_bounds(iBBox), x_channel(SChan), x_parent(SParent), x_colour(0, 0, 0, 0), x_visible(iVisible))
    xout bb_parentContext(iBBox)
endop

opcode makeParentContainer, i[], i[]SS
    iBBox[], SChan, SParent xin

    xout makeParentContainer(iBBox, SChan, SParent, 1)
endop

opcode makeParentContainer, i[], i[]S
    iBBox[], SChan xin

    xout makeParentContainer(iBBox, SChan, "")
endop

gSSelectorButtons[] = fillarray(x_colour2(0, 0, 0, 0, 255), x_colour2(1, 0, 255, 0, 255), x_corners(4))

opcode labelBB, i[], i[]i
    iBB[], iLabelSize xin
    xout bb_inside(bb_inside(iBB, iLabelSize, iLabelSize, "lm"), bb_h(iBB), iLabelSize - 6, "cm")
endop

opcode widgetBB, i[], i[]i
    iBB[], iLabelSize xin

    xout bb_inside(iBB, bb_w(iBB) - iLabelSize, 0, "rm")
endop

opcode createBBoxes, i[]i[], i[]iii
    iBB[], iLabelSize, iX, iY xin

    xout labelBB(iBB, iLabelSize), widgetBB(iBB, iLabelSize)
endop

opcode createBBoxes2, i[]i[], i[]ii
    iBB[], iLabelSize, iKnobSize xin
    xout labelBB(iBB, iLabelSize), bb_inside(widgetBB(iBB, iLabelSize), iKnobSize, iKnobSize, "lm")
endop

opcode createLabel, 0, i[]SSS
    iBB[], SChannel, SParent, SLabel xin
    x_create "label", fillarray(\
        x_bounds(iBB),\
        x_channel(sprintf("%s%slab", SChannel, SLabel)),\
        x_parent(SParent),\
        x_text(SLabel),\
        x_align("centre"),\
        x_fontColour(255, 255, 255, 127),\
        x_rotateCentered(iBB, 300))
endop

opcode createTag, S, S
    SKey xin
    STag = ""
    if strcmp("", SKey) != 0 then
        STag = x__tag("obj", SKey)
    endif
    xout STag
endop

opcode createComboBox, 0, i[]SSSSS
    iBB[], SChannel, SParent, SLabel, SKey, SItems xin
    STag = createTag(SKey)
    x_create "combobox", fillarray(\
        STag,\
        x_bounds(iBB),\
        x_channel(sprintf("%s%s", SChannel, SLabel)),\
        x_parent(SParent),\
        x_align("left"),\
        SItems)
endop

opcode createButton, 0, i[]SSSSSo
    iBB[], SChannel, SParent, SLabel, SKey, SItems, iLatched xin
    STag = createTag(SKey)
    x_create "button", fillarray(\
        STag,\
        x_bounds(iBB),\
        x_channel(sprintf("%s%s", SChannel, SLabel)),\
        x_parent(SParent),\
        x_align("left"),\
        x_latched(iLatched),\
        SItems)
endop

opcode createOptionButton, 0, i[]SSSSSo
    iBB[], SChannel, SParent, SLabel, SKey, SItems, iLatched xin
    STag = createTag(SKey)
    x_create "optionbutton", fillarray(\
        STag,\
        x_bounds(iBB),\
        x_channel(sprintf("%s%s", SChannel, SLabel)),\
        x_parent(SParent),\
        x_align("left"),\
        x_latched(0),\
        SItems)
endop

opcode createRSlider, 0, i[]SSSSS
    iBB[], SChannel, SParent, SLabel, SKey, SRange xin

    STag = createTag(SKey)
    x_create "rslider", fillarray(\
        STag,\
        x_bounds(iBB),\
        x_channel(sprintf("%s%s", SChannel, SLabel)),\
        x_parent(SParent),\
        SRange)
endop

gSUnderlayColour = x_colour(255, 255, 255, 60)
gSUnderlayActiveColour = x_colour(255, 0, 0, 50)

; iBB[] is the bounding box within the parent object
; SParent is the name of the parent container object
; for each part - create parent container, create label container, create label
opcode makePartLabel, 0, i[]SSiiii
    iBB[], SParent, SChanRoot, iPartCount, iKnobSize, iLabelSize, iSelectButtonSize xin

    iLabelBB[], iSelectBB[] bb_split iBB, "v"
    iLabelBB[] = bb_inside(iLabelBB, 0, iLabelSize, "lm")
    iSelectBBoxes[][] bb_split iSelectBB, iPartCount, "v"

;    x_img x_bounds(iLabelBB), x_colour(255, 0, 0, 255), x_parent(SParent)
;    x_img x_bounds(getrow(iSelectBBoxes, 0)), x_colour(255, 0, 255, 50), x_parent(SParent)
;    x_img x_bounds(getrow(iSelectBBoxes, 1)), x_colour(255, 0, 255, 100), x_parent(SParent)
;    x_img x_bounds(getrow(iSelectBBoxes, 2)), x_colour(255, 0, 255, 150), x_parent(SParent)
;    x_img x_bounds(getrow(iSelectBBoxes, 3)), x_colour(255, 0, 255, 200), x_parent(SParent)

    x_create "label", fillarray(\
        x_bounds(iLabelBB),\
        x_channel(sprintf("%slabX", SChanRoot)),\
        x_parent(SParent),\
        x_text("part"),\
        x_align("left"))

    SParentGrp = sprintf("%sgrp", SParent)
    iCount = 0
    while iCount < iPartCount do
        SChan = sprintf("%s%dsel", SChanRoot, iCount)
        x_create "checkbox", fillarray(\
            x_bounds(bb_inside(getrow(iSelectBBoxes, iCount), iSelectButtonSize, iSelectButtonSize, "cm")),\
            x_channel(SChan),\
            x_parent(SParent),\
            x_radioGroup(SParentGrp))\
        , gSSelectorButtons

        iCount += 1
    od
endop

opcode makeOpLabel, 0, i[]SSiiiii
    iBB[], SParent, SChanRoot, iPartCount, iOperatorCount, iKnobSize, iLabelSize, iSelectButtonSize xin

    iLabelBB[], iSelectBB[] bb_split iBB, "v"
    iLabelBB[] = bb_inside(iLabelBB, 0, iLabelSize, "lm")
    iSelectBBoxes[][] bb_split iSelectBB, iOperatorCount, "v"

;    x_img x_bounds(iLabelBB), x_colour(255, 0, 0, 255), x_parent(SParent)
;    x_img x_bounds(getrow(iSelectBBoxes, 0)), x_colour(255, 0, 255, 50), x_parent(SParent)
;    x_img x_bounds(getrow(iSelectBBoxes, 1)), x_colour(255, 0, 255, 100), x_parent(SParent)
;    x_img x_bounds(getrow(iSelectBBoxes, 2)), x_colour(255, 0, 255, 150), x_parent(SParent)
;    x_img x_bounds(getrow(iSelectBBoxes, 3)), x_colour(255, 0, 255, 200), x_parent(SParent)

    iLabelBB[] = bb_trim(bb_inside(iBB, 0, iLabelSize, "lm"), "x", 4)
    iCount = 0
    while iCount < iPartCount do
        SLabelText = sprintf("%s%d", SChanRoot, iCount)
        SLabelParent = sprintf("%soplab", SLabelText)
        iBlankBB[] = makeParentContainer(iBB, SLabelParent, SParent, 1)
        x_create "label", fillarray(\
            x_bounds(iLabelBB),\
            x_channel(sprintf("%sX", SLabelParent)),\
            x_parent(SLabelParent),\
            x_text(sprintf("op%d", iCount)),\
            x_align("left"))

        SParentGrp = sprintf("%s%dgrp", SChanRoot, iCount)
        iOCount = 0
        while iOCount < iOperatorCount do
            SChan = sprintf("%s%dop%dsel", SChanRoot, iCount, iOCount)
            x_create "checkbox", fillarray(\
                x_bounds(bb_inside(getrow(iSelectBBoxes, iOCount), iSelectButtonSize, iSelectButtonSize, "cm")),\
                x_channel(SChan),\
                x_parent(SLabelParent),\
                x_radioGroup(SParentGrp))\
            , gSSelectorButtons

            iOCount += 1
        od
        iCount += 1
    od
endop

opcode makePatchSets, 0, i[]SSi
    iBB[], SParent, SLabelRoot, iLabelSize xin

    SSaveOptions[] = fillarray("cmds", "save" , "load", "import")
    iNilBB[], iCmdBB[] bb_split iBB, "v"
;    x_img x_bounds(iCmdBB), x_colour(255, 0, 0, 60), x_parent(SParent)
;    x_img x_bounds(iNilBB), x_colour(255, 0, 0, 120), x_parent(SParent)

    x_create "combobox", fillarray(\
        x_bounds(iCmdBB),\
        x_channel(sprintf("%scmd", SLabelRoot)),\
        x_parent(SParent),\
        x_align("left"),\
        x_latched(0),\
        x_items(SSaveOptions))
endop

opcode makePartGlobal, 0, i[]SSiii
    iBB[], SParent, SLabelRoot, iPartCount, iKnobSize, iLabelSize xin
    iSegments[] = fillarray(4, 4, 4, 4, 9, 25)
    iSegmentsBBoxes[][] bb_choose iBB, iSegments, "h"
    SRoot = "glob"

    iPatchBB[], iSaveBB[] bb_split getrow(iSegmentsBBoxes, 0), "v"
    iPatchLabelBB[], iPatchBB[] createBBoxes iPatchBB, iLabelSize, bb_w(iPatchBB) - iLabelSize, iKnobSize
    iSaveLabelBB[], iSaveBB[] createBBoxes iSaveBB, iLabelSize, bb_w(iSaveBB) - iLabelSize, iKnobSize

    iSrcBB[], iNilBB[] bb_split getrow(iSegmentsBBoxes, 1), "v", .6
    iSrcLabelBB[], iSrcBB[] createBBoxes iSrcBB, iLabelSize, bb_w(iSrcBB) - iLabelSize, iKnobSize

    iScaleBB[], iTransposeBB[] bb_split getrow(iSegmentsBBoxes, 2), "v", .6
    iScaleLabelBB[], iScaleBB[] createBBoxes iScaleBB, iLabelSize, bb_w(iScaleBB) - iLabelSize, iKnobSize
    iTransposeLabelBB[], iTransposeBB[] createBBoxes2 iTransposeBB, iLabelSize, iKnobSize

    iAlgorithmBB[], iNilBB[] bb_split getrow(iSegmentsBBoxes, 3), "v", .6
    iAlgorithmLabelBB[], iAlgorithmBB[] createBBoxes iAlgorithmBB, iLabelSize, bb_w(iAlgorithmBB) - iLabelSize, iKnobSize

    iNilBB[], iFeedbackBB[] bb_split getrow(iSegmentsBBoxes, 4), "v", .6
    iFeedbackLabelBB[], iFeedbackBB[] createBBoxes2 iFeedbackBB, iLabelSize, iKnobSize

    iDisplayBB[] = getrow(iSegmentsBBoxes, 5)

    createLabel(iPatchLabelBB, SLabelRoot, SParent, "pat")
    createLabel(iSaveLabelBB, SLabelRoot, SParent, "sav")
    createLabel(iSrcLabelBB, SLabelRoot, SParent, "src")
    createLabel(iScaleLabelBB, SLabelRoot, SParent, "scl")
    createLabel(iAlgorithmLabelBB, SLabelRoot, SParent, "alg")
    x_img x_bounds(bb_inset(iTransposeBB, -2, -2)), x_colour(255, 0, 0, 50), x_parent(SParent)
    createLabel(iTransposeLabelBB, SLabelRoot, SParent, "trn")
    x_img x_bounds(bb_inset(iFeedbackBB, -2, -2)), x_colour(255, 0, 0, 50), x_parent(SParent)
    createLabel(iFeedbackLabelBB, SLabelRoot, SParent, "fdbk")

    x_img x_bounds(iDisplayBB), x_colour(0, 180, 0, 255), x_parent(SParent)

    SPatchOptions[] = fillarray("1", "2", "3", "4", "5", "6", "7", "8", "9", "10", "11", "12", "13", "14", "15", "16", "17", "18", "19", "20", "21", "22", "23", "24", "25", "26", "27", "28", "29", "30")
    SSaveOptions[] = fillarray("save" /* , "load" */)
    SSrcOptions[] = fillarray(\
                "midi 1", "midi 2", "midi 3", "midi 4", "midi 5", "midi 6", "midi 7", "midi 8",\
                "midi 9", "midi 10", "midi 11", "midi 12", "midi 13", "midi 14", "midi 15", "midi 16",\
                "nil", "alg 1", "alg 2", "alg 3", "alg 4" )
    SSclOptions[] = fillarray("5et", "7et", "8et", "9et", "10et", "11et", "12et", "13et")
    SAlgorithmOptions = sprintf("%s %s %s %s",\
        x_items(1, x_arrayCat(fillarray("_op1", "op1alg1"), 1, 1)),\
        x_items(2, x_arrayCat(fillarray("_op2", "op2alg1", "op2alg2", "op2alg3"), 1, 1)),\
        x_items(3, x_arrayCat(fillarray("_op3", "op3alg1", "op3alg2", "op3alg3", "op3alg4", "op3alg5", "op3alg6", "op3alg7", "op3alg8", "op3alg9", "op3alg10"), 1, 1)),\
        x_items(4, x_arrayCat(fillarray("_dx9", "dx9alg1", "dx9alg2", "dx9alg3", "dx9alg4", "dx9alg5", "dx9alg6", "dx9alg7", "dx9alg8"), 1, 1)))
;    prints("%s\n", SAlgorithmOptions)
    iPCount = 0
    while iPCount < iPartCount do
        SPartKey = sprintf("%s%d", SLabelRoot, iPCount)
        SPartParentKey = sprintf("%s%s", SPartKey, SRoot)
        iPartParent[] = makeParentContainer(iBB, SPartParentKey, SParent)

        createComboBox(iPatchBB, SPartKey, SPartParentKey, "pat", "", x_items(SPatchOptions))
        createButton(iSaveBB, SPartKey, SPartParentKey, "sav", "", x_items(SSaveOptions))

        createComboBox(iSrcBB, SPartKey, SPartParentKey, "src", SPartKey, x_items(SSrcOptions))

        createComboBox(iScaleBB, SPartKey, SPartParentKey, "scl", SPartKey, x_items(SSclOptions))
        createRSlider(iTransposeBB, SPartKey, SPartParentKey, "trn", SPartKey, x_range(-8, 8, 0, 1, 1))

        createComboBox(iAlgorithmBB, SPartKey, SPartParentKey, "alg", SPartKey, SAlgorithmOptions)

        createRSlider(iFeedbackBB, SPartKey, SPartParentKey, "fdbk", SPartKey, x_range(-8, 8, 0, 1, 1))

        iPCount += 1
    od
endop

opcode makeGraphicActive, 0, i[]SSS
    iBB[], SParent, SChannel, SColour xin
    x_img x_bounds(bb_inset(iBB, -2, -2)), x_parent(SParent), x_channel(SChannel), SColour
endop

opcode makeGraphicInactive, 0, i[]S
    iBB[], SParent xin
    x_img x_bounds(bb_inset(iBB, 8, 8)), x_parent(SParent), gSUnderlayColour
endop

opcode makeGraphicUnderlay, 0, i[]SS
    iBB[], SParent, SChannel xin
    makeGraphicInactive(iBB, SParent)
    makeGraphicActive(iBB, SParent, SChannel, gSUnderlayActiveColour)
;    x_img x_bounds(bb_inset(iBB, 8, 8)), gSUnderlayColour, x_parent(SParent)
;    x_img x_bounds(bb_inset(iBB, -2, -2)), x_colour(255, 0, 0, 50), x_parent(SParent), x_channel(SChannel)
endop

opcode makeOsc, 0, i[]SSiiiiii
    iBB[], SParent, SLabelRoot, iPartCount, iOperatorCount, iKnobSize, iLabelSize, iLabelTrim, iSelectButtonSize xin

    iSegments[] = fillarray(4, 11, 1, 10, 11, 6, 7)
    iSegmentsBBoxes[][] bb_choose iBB, iSegments, "h"
;    iSegmentsBBoxes[][] bb_split iBB, 7, "h"

    iWaveBB[], iModeBB[] bb_split getrow(iSegmentsBBoxes, 0), "v"
    iWaveLabelBB[], iWaveBB[] createBBoxes iWaveBB, iLabelSize, bb_w(iWaveBB) - iLabelSize, iKnobSize
    iModeLabelBB[], iModeBB[] createBBoxes iModeBB, iLabelSize, bb_w(iModeBB) - iLabelSize, iKnobSize

    iBBoxes[][] bb_split getrow(iSegmentsBBoxes, 1), 3, "v"
    iOctaveLabelBB[], iOctaveBB[] createBBoxes2 getrow(iBBoxes, 0), iLabelSize, iKnobSize
    iStepLabelBB[], iStepBB[] createBBoxes2 getrow(iBBoxes, 1), iLabelSize, iKnobSize
    iCentLabelBB[], iCentBB[] createBBoxes2 getrow(iBBoxes, 2), iLabelSize, iKnobSize

    iBBoxes[][] bb_pack iOctaveBB, iStepBB, iCentBB
    iPitchInlayBB[] = bb_enclosing(iBBoxes)

    iDisplayBB[] = bb_inside(getrow(iSegmentsBBoxes, 2), 0, iLabelSize * .75, "cb")

    iPhaseBB[], iIndexBB[] bb_split getrow(iSegmentsBBoxes, 3), "v"
    iPhaseLabelBB[], iPhaseBB[] createBBoxes2 iPhaseBB, iLabelSize, iKnobSize
    iPhaseRndBB[] = bb_outside(iPhaseBB, iLabelSize * .5, iLabelSize * .5, "rm")
    iIndexLabelBB[], iIndexBB[] createBBoxes2 iIndexBB, iLabelSize, iKnobSize

    iBBoxes[][] bb_pack iPhaseBB, iIndexBB
    iPhaseInlayBB[] = bb_enclosing(iBBoxes)

    iBBoxes[][] bb_split getrow(iSegmentsBBoxes, 4), 3, "v"
    iModSenseLabelBB[], iModSenseBB[] createBBoxes2 getrow(iBBoxes, 0), iLabelSize, iKnobSize
    iKeyVelLabelBB[], iKeyVelBB[] createBBoxes2 getrow(iBBoxes, 1), iLabelSize, iKnobSize
    iLevelLabelBB[], iLevelBB[] createBBoxes2 getrow(iBBoxes, 2), iLabelSize, iKnobSize

    iBBoxes[][] bb_pack iModSenseBB, iKeyVelBB, iLevelBB
    iSenseInlayBB[] = bb_enclosing(iBBoxes)

    iBBoxes[][] bb_split getrow(iSegmentsBBoxes, 5), 3, "v"
    iLeftDepthLabelBB[], iLeftDepthBB[] createBBoxes2 getrow(iBBoxes, 0), iLabelSize, iKnobSize
    iBreakpointLabelBB[], iBreakpointBB[] createBBoxes2 getrow(iBBoxes, 1), iLabelSize, iKnobSize
    iRightDepthLabelBB[], iRightDepthBB[] createBBoxes2 getrow(iBBoxes, 2), iLabelSize, iKnobSize

    iBBoxes[][] bb_split getrow(iSegmentsBBoxes, 6), 3, "v"
    iLeftCurveLabelBB[], iLeftCurveBB[] createBBoxes2 getrow(iBBoxes, 0), iLabelSize, iKnobSize
    iRateScalingLabelBB[], iRateScalingBB[] createBBoxes2 getrow(iBBoxes, 1), iLabelSize, iKnobSize
    iRightCurveLabelBB[], iRightCurveBB[] createBBoxes2 getrow(iBBoxes, 2), iLabelSize, iKnobSize

    iBBoxes[][] bb_pack iLeftDepthBB, iBreakpointBB, iRightDepthBB, iLeftCurveBB, iRateScalingBB, iRightCurveBB
    iBreakpointInlayBB[] = bb_enclosing(iBBoxes)

    makeGraphicUnderlay(iPitchInlayBB, SParent, "partpitchul")
    makeGraphicUnderlay(iPhaseInlayBB, SParent, "partphaseul")
    makeGraphicUnderlay(iSenseInlayBB, SParent, "partsenseul")
    makeGraphicUnderlay(iBreakpointInlayBB, SParent, "partbpointul")

    createLabel(iWaveLabelBB, sprintf("%sop", SParent), SParent, "wv")
    createLabel(iModeLabelBB, sprintf("%sop", SParent), SParent, "md")

    createLabel(iOctaveLabelBB, sprintf("%sop", SParent), SParent, "octave")
    createLabel(iStepLabelBB, sprintf("%sop", SParent), SParent, "step")
    createLabel(iCentLabelBB, sprintf("%sop", SParent), SParent, "cent")

    createLabel(iPhaseLabelBB, sprintf("%sop", SParent), SParent, "phase")
    createLabel(iIndexLabelBB, sprintf("%sop", SParent), SParent, "index")

    createLabel(iModSenseLabelBB, sprintf("%sop", SParent), SParent, "mods")
    createLabel(iKeyVelLabelBB, sprintf("%sop", SParent), SParent, "keyv")
    createLabel(iLevelLabelBB, sprintf("%sop", SParent), SParent, "level")

    createLabel(iLeftDepthLabelBB, sprintf("%sop", SParent), SParent, "ldep")
    createLabel(iBreakpointLabelBB, sprintf("%sop", SParent), SParent, "bpnt")
    createLabel(iRightDepthLabelBB, sprintf("%sop", SParent), SParent, "rdep")
    createLabel(iLeftCurveLabelBB, sprintf("%sop", SParent), SParent, "lcrv")
    createLabel(iRateScalingLabelBB, sprintf("%sop", SParent), SParent, "rscl")
    createLabel(iRightCurveLabelBB, sprintf("%sop", SParent), SParent, "rcrv")
;    x_img x_bounds(iPitchInlayBB), gSUnderlayColour, x_parent(SParent)
;    x_img x_bounds(bb_inset(iPitchInlayBB, -10, -10)), x_colour(255, 0, 0, 50), x_parent(SParent)
;    x_img x_bounds(iPhaseInlayBB), gSUnderlayColour, x_parent(SParent)
;    x_img x_bounds(bb_inset(iPhaseInlayBB, -10, -10)), x_colour(255, 0, 0, 50), x_parent(SParent)
;    x_img x_bounds(iSenseInlayBB), gSUnderlayColour, x_parent(SParent)
;    x_img x_bounds(bb_inset(iSenseInlayBB, -10, -10)), x_colour(255, 0, 0, 50), x_parent(SParent)
;    x_img x_bounds(iBreakpointInlayBB), gSUnderlayColour, x_parent(SParent)
;    x_img x_bounds(bb_inset(iBreakpointInlayBB, -10, -10)), x_colour(255, 0, 0, 50), x_parent(SParent)
;    x_img x_bounds(iBB), x_colour(255, 0, 0, 255), x_parent(SParent)
;    x_img x_bounds(iWaveLabelBB), x_colour(0, 255, 0, 120), x_parent(SParent)
;    x_img x_bounds(iWaveBB), x_colour(0, 255, 0, 120), x_parent(SParent)
;    x_img x_bounds(iModeLabelBB), x_colour(0, 0, 255, 120), x_parent(SParent)
;    x_img x_bounds(iModeBB), x_colour(0, 0, 255, 120), x_parent(SParent)
;
;    x_img x_bounds(iOctaveLabelBB), x_colour(0, 255, 0, 40), x_parent(SParent)
;    x_img x_bounds(iOctaveBB), x_colour(0, 255, 0, 40), x_parent(SParent)
;    x_img x_bounds(iStepLabelBB), x_colour(0, 255, 0, 40), x_parent(SParent)
;    x_img x_bounds(iStepBB), x_colour(0, 255, 0, 40), x_parent(SParent)
;    x_img x_bounds(iCentLabelBB), x_colour(0, 255, 0, 40), x_parent(SParent)
;    x_img x_bounds(iCentBB), x_colour(0, 255, 0, 40), x_parent(SParent)
;
;    x_img x_bounds(iDisplayBB), x_colour(0, 255, 0, 60), x_parent(SParent)
;
;    x_img x_bounds(iPhaseLabelBB), x_colour(0, 255, 0, 80), x_parent(SParent)
;    x_img x_bounds(iPhaseBB), x_colour(0, 255, 0, 80), x_parent(SParent)
;    x_img x_bounds(iPhaseRndBB), x_colour(0, 255, 0, 80), x_parent(SParent)
;    x_img x_bounds(iIndexLabelBB), x_colour(0, 255, 0, 80), x_parent(SParent)
;    x_img x_bounds(iIndexBB), x_colour(0, 255, 0, 80), x_parent(SParent)
;
;    x_img x_bounds(iModSenseLabelBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iModSenseBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iKeyVelLabelBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iKeyVelBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iLevelLabelBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iLevelBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;
;    x_img x_bounds(iLeftDepthLabelBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iLeftDepthBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iBreakpointLabelBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iBreakpointBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iRightDepthLabelBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iRightDepthBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;
;    x_img x_bounds(iLeftCurveLabelBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iLeftCurveBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iRateScalingLabelBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iRateScalingBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iRightCurveLabelBB), x_colour(0, 255, 0, 100), x_parent(SParent)
;    x_img x_bounds(iRightCurveBB), x_colour(0, 255, 0, 100), x_parent(SParent)

    iPCount = 0
    SRoot = "op"
    SWaveOptions[] = fillarray("sin", "cos", "tri", "saw", "sqr", "u_1", "u_2", "u_3", "u_4", "u_5", "u_6", "u_7", "u_8")
    SModeOptions[] = fillarray("ratio", "fixed")
    while iPCount < iPartCount do
        iOCount = 0
        SPartKey = sprintf("%s%d", SLabelRoot, iPCount)
        SSelectGrp = sprintf("%sopgrp", SPartKey)
        SPartParentKey = sprintf("%s%s", SPartKey, SRoot)
        iPartParent[] = makeParentContainer(iBB, SPartParentKey, SParent)
        while iOCount < iOperatorCount do
   ; iBB[], iLabelBB[], SChannel, SLabel, SKey, SRange xin
            SLabelText = sprintf("%s%d", SRoot, iOCount)
            SOpChan = sprintf("%s%s", SPartKey, SLabelText)
            ; create the operator parent widget
            iOpParent[] = makeParentContainer(iBB, SOpChan, SPartParentKey)

            SChannel = sprintf("%s%d", SPartParentKey, iOCount)
            createComboBox(iWaveBB, SChannel, SOpChan, "wv", SPartKey, x_items(SWaveOptions))
            createOptionButton(iModeBB, SChannel, SOpChan, "md", SPartKey, x_items(SModeOptions), 1)

            createRSlider(iOctaveBB, SChannel, SOpChan, "octave", SPartKey, x_range(-8, 8, 0, 1, 1))
            createRSlider(iStepBB, SChannel, SOpChan, "step", SPartKey, x_range(-12, 12, 0, 1, 1))
            createRSlider(iCentBB, SChannel, SOpChan, "cent", SPartKey, x_range(-100, 100, 0, 1, 0.25))

            x_create "label", fillarray(\
                x_bounds(iDisplayBB),\
                x_channel(sprintf("%spitchdisplay", SOpChan)),\
                x_parent(SOpChan),\
                x_text("0"),\
                x_align("centre"))

            createRSlider(iPhaseBB, SChannel, SOpChan, "phase", SPartKey, x_range(-1, 1, 0, 1, 0.01))
            x_create "checkbox", fillarray(\
                x__tag("obj", SPartKey),\
                x_bounds(iPhaseRndBB),\
                x_channel(sprintf("%sphasernd", SOpChan)),\
                x_parent(SOpChan))\
                , gSSelectorButtons

            createRSlider(iIndexBB, SChannel, SOpChan, "index", SPartKey, x_range(0, 100, 0, 1, 0.25))

            createRSlider(iModSenseBB, SChannel, SOpChan, "mods", SPartKey, x_range(-8, 8, 0, 1, 1))
            createRSlider(iKeyVelBB, SChannel, SOpChan, "keyv", SPartKey, x_range(-12, 12, 0, 1, 1))
            createRSlider(iLevelBB, SChannel, SOpChan, "level", SPartKey, x_range(-100, 100, 0, 1, 0.25))

            createRSlider(iLeftDepthBB, SChannel, SOpChan, "ldep", SPartKey, x_range(-8, 8, 0, 1, 1))
            createRSlider(iBreakpointBB, SChannel, SOpChan, "bpnt", SPartKey, x_range(-12, 12, 0, 1, 1))
            createRSlider(iRightDepthBB, SChannel, SOpChan, "rdep", SPartKey, x_range(-100, 100, 0, 1, 0.25))

            createRSlider(iLeftCurveBB, SChannel, SOpChan, "lcrv", SPartKey, x_range(-8, 8, 0, 1, 1))
            createRSlider(iRateScalingBB, SChannel, SOpChan, "rscl", SPartKey, x_range(-12, 12, 0, 1, 1))
            createRSlider(iRightCurveBB, SChannel, SOpChan, "rcrv", SPartKey, x_range(-100, 100, 0, 1, 0.25))

            iOCount += 1
        od
        iPCount += 1
    od
endop

opcode makeEnvelope2, 0, i[]SSiiiii
    iBB[], SParent, SLabelRoot, iPartCount, iOperatorCount, iKnobSize, iLabelSize, iLabelTrim xin
    iBBoxes[][] bb_split iBB, 2, 20, "tblr"

;    printarray iBBoxes
    iSegments[] = fillarray(0, 4, 8, 12, 16, 22, 26, 30, 34)
    SLabelText[] = fillarray("lev0", "lev1", "lev2", "lev3", "lev4", "rate0", "rate1", "rate2", "rate3")
    SRanges[] = fillarray( \
        x_range(0, 1, 0, 1, .01), \
        x_range(0, 1, 1, 1, .01), \
        x_range(0, 1, .7, 1, .01), \
        x_range(0, 1, .3, 1, .01), \
        x_range(0, 1, 0, 1, .01), \
        x_range(0, 1, 1, 1, .01), \
        x_range(0, 1, 1, 1, .01), \
        x_range(0, 1, 1, 1, .01), \
        x_range(0, 1, 1, 1, .01))
    iStage[] = fillarray(0, 0, 0, 0, 1, 0, 0, 0, 1)
    iLen = lenarray(iSegments)
    iKnobLabelBBoxes[][] init iLen, 4
    iKnobBBoxes[][] init iLen, 4
    iCount = 0
    while iCount < iLen do
        iBB2[] = bb_expand(getrow(iBBoxes, iSegments[iCount]), 1, 4)
        iLabelBB[], iObjBB[] createBBoxes2 iBB2, iLabelSize, iKnobSize
        iKnobLabelBBoxes = setrow(iLabelBB, iCount)
        iKnobBBoxes = setrow(iObjBB, iCount)
;        x_img x_bounds(iBB2), gSUnderlayColour, x_parent(SParent)
;        x_img x_bounds(getrow(iKnobLabelBBoxes, iCount)), gSUnderlayColour, x_parent(SParent)
;        x_img x_bounds(getrow(iKnobBBoxes, iCount)), gSUnderlayColour, x_parent(SParent)

        iCount += 1
    od
    iBBoxes[][] bb_pack getrow(iKnobBBoxes, 0), getrow(iKnobBBoxes, 1), getrow(iKnobBBoxes, 2), getrow(iKnobBBoxes, 3), getrow(iKnobBBoxes, 4)
    iLevelInlayBB[] = bb_enclosing(iBBoxes)
    iBBoxes[][] bb_pack getrow(iKnobBBoxes, 0), getrow(iKnobBBoxes, 1), getrow(iKnobBBoxes, 2), getrow(iKnobBBoxes, 3)
    iLevelInactiveBB[] = bb_enclosing(iBBoxes)

    iBBoxes[][] bb_pack getrow(iKnobBBoxes, 5), getrow(iKnobBBoxes, 6), getrow(iKnobBBoxes, 7), getrow(iKnobBBoxes, 8)
    iRateInlayBB[] = bb_enclosing(iBBoxes)
    iBBoxes[][] bb_pack getrow(iKnobBBoxes, 5), getrow(iKnobBBoxes, 6), getrow(iKnobBBoxes, 7)
    iRateInactiveBB[] = bb_enclosing(iBBoxes)

    makeGraphicInactive(iLevelInactiveBB, SParent)
    makeGraphicActive(iLevelInlayBB, SParent, "partenvlul", gSUnderlayActiveColour)
    makeGraphicInactive(iRateInactiveBB, SParent)
    makeGraphicActive(iRateInlayBB, SParent, "partenvrul", gSUnderlayActiveColour)
    iCount = 0
    while iCount < iLen do
; iBB[], SChannel, SParent, SLabel xin
        createLabel(getrow(iKnobLabelBBoxes, iCount), sprintf("%senv", SParent), SParent, SLabelText[iCount])
        iCount += 1
    od
    iPCount = 0
    SRoot = "env"
    while iPCount < iPartCount do
        SPartKey = sprintf("%s%d", SLabelRoot, iPCount)
        SPartParentKey = sprintf("%s%s", SPartKey, SRoot)
        iPartParent[] = makeParentContainer(iBB, SPartParentKey, SParent)
        iOCount = 0
        while iOCount < iOperatorCount do
            SOpChan = sprintf("%s%d", SPartParentKey, iOCount)
            iOpParent[] = makeParentContainer(iBB, SOpChan, SPartParentKey)
            iCount = 0
            while iCount < iLen do
                x_create "rslider", fillarray(\
                    x__tag("obj", SPartKey),\
                    x_bounds(getrow(iKnobBBoxes, iCount)),\
                    x_channel(sprintf("%s%s", SOpChan, SLabelText[iCount])),\
                    x_parent(SOpChan),\
                    SRanges[iCount])

                iCount += 1
            od
            iOCount += 1
        od
        iPCount += 1
    od
endop

opcode makeEnvelope, 0, i[]SSiiiii
    iBB[], SParent, SLabelRoot, iPartCount, iOperatorCount, iKnobSize, iLabelSize, iLabelTrim xin
    iBBoxes[][] bb_split iBB, 2, 20, "tblr"

    iSegments[] = fillarray(0, 4, 8, 12, 16, 22, 26, 30, 34)
    SKnobPos[] = fillarray("rm", "rm", "rm", "rm", "rm", "lm", "lm", "lm", "lm")
    SLabelPos[] = fillarray("rm", "rm", "rm", "rm", "rm", "lm", "lm", "lm", "lm")
    SLabelAlign[] = fillarray("left", "left", "left", "left", "left", "right", "right", "right", "right")
    SLabelText[] = fillarray("l0", "l1", "l2", "l3", "l4", "r0", "r1", "r2", "r3")
    SParamText[] = fillarray("level0", "level1", "level2", "level3", "level4", "rate0", "rate1", "rate2", "rate3")
    SRanges[] = fillarray( \
        x_range(0, 1, 0, 1, .01), \
        x_range(0, 1, 1, 1, .01), \
        x_range(0, 1, .7, 1, .01), \
        x_range(0, 1, .3, 1, .01), \
        x_range(0, 1, 0, 1, .01), \
        x_range(0, 1, 1, 1, .01), \
        x_range(0, 1, 1, 1, .01), \
        x_range(0, 1, 1, 1, .01), \
        x_range(0, 1, 1, 1, .01))
    iStage[] = fillarray(0, 0, 0, 0, 1, 0, 0, 0, 1)
    iLen = lenarray(iSegments)
    iKnobBBoxes[][] init iLen, 4
    iKnobInsetBBoxes[][] init iLen, 4
    SKnobInsetColours[] init iLen
    iLabelBBoxes[][] init iLen, 4
    iCount = 0
    while iCount < iLen do
        iBB2[] = bb_inside(bb_inset(bb_expand(getrow(iBBoxes, iSegments[iCount]), 1, 4), 15, 0), iKnobSize, iKnobSize, SKnobPos[iCount])
        iKnobBBoxes = setrow(iBB2, iCount)
        iKnobInsetBBoxes = setrow(bb_inset(iBB2, -2, -2), iCount)
        if iStage[iCount] == 1 then
            SKnobInsetColours[iCount] = x_colour(120, 40, 40, 100)
        else
            SKnobInsetColours[iCount] = x_colour(40, 40, 120, 100)
        endif
        iLabelBBoxes = setrow(bb_inset(bb_outside(iBB2, 62, iLabelSize, SLabelPos[iCount]), 4, 0), iCount)
        iCount += 1
    od

    iBBoxes[][] bb_pack getrow(iKnobBBoxes, 0), getrow(iKnobBBoxes, 1), getrow(iKnobBBoxes, 2), getrow(iKnobBBoxes, 3)
    iLevelInlayBB[] = bb_inset(bb_enclosing(iBBoxes), 8, 8)

;    iBBoxes[][] bb_pack getrow(iKnobBBoxes, 4)
;    iRelLevelInlayBB[] = bb_inset(bb_enclosing(iBBoxes), 8, 8)

    iBBoxes[][] bb_pack getrow(iKnobBBoxes, 0), getrow(iKnobBBoxes, 1), getrow(iKnobBBoxes, 2), getrow(iKnobBBoxes, 3), getrow(iKnobBBoxes, 4)
    iLevel2InlayBB[] = bb_inset(bb_enclosing(iBBoxes), -4, -4)

    iBBoxes[][] bb_pack getrow(iKnobBBoxes, 5), getrow(iKnobBBoxes, 6), getrow(iKnobBBoxes, 7)
    iRateInlayBB[] = bb_inset(bb_enclosing(iBBoxes), 8, 8)

    iBBoxes[][] bb_pack getrow(iKnobBBoxes, 8), getrow(iKnobBBoxes, 9)
    iRelRateInlayBB[] = bb_inset(bb_enclosing(iBBoxes), 8, 8)

    iBBoxes[][] bb_pack getrow(iKnobBBoxes, 5), getrow(iKnobBBoxes, 6), getrow(iKnobBBoxes, 7), getrow(iKnobBBoxes, 8)
    iRate2InlayBB[] = bb_inset(bb_enclosing(iBBoxes), -4, -4)

;    x_img x_bounds(iLevelInlayBB), gSUnderlayColour, x_parent(SParent)
;    x_img x_bounds(bb_inset(iLevelInlayBB, -12, -12)), x_colour(255, 0, 0, 50), x_parent(SParent)
;    x_img x_bounds(iRelLevelInlayBB), gSUnderlayColour, x_parent(SParent)
;    x_img x_bounds(bb_inset(iRelLevelInlayBB, -12, -12)), x_colour(255, 0, 0, 50), x_parent(SParent)
;    x_img x_bounds(iLevel2InlayBB), x_colour(255, 0, 0, 50), x_parent(SParent)
;    x_img x_bounds(iRateInlayBB), gSUnderlayColour, x_parent(SParent)
;    x_img x_bounds(bb_inset(iRateInlayBB, -10, -10)), x_colour(255, 0, 0, 50), x_parent(SParent)
;    x_img x_bounds(iRelRateInlayBB), gSUnderlayColour, x_parent(SParent)
;    x_img x_bounds(bb_inset(iRelRateInlayBB, -10, -10)), x_colour(255, 0, 0, 50), x_parent(SParent)
;    x_img x_bounds(iRate2InlayBB), x_colour(255, 0, 0, 50), x_parent(SParent)

;    iPCount = 0
;    SRoot = "env"
;    while iPCount < iPartCount do
;        SPartKey = sprintf("%s%d", SLabelRoot, iPCount)
;        SPartParentKey = sprintf("%s%s", SPartKey, SRoot)
;        iPartParent[] = makeParentContainer(iBB, SPartParentKey, SParent)
;        iOCount = 0
;        while iOCount < iOperatorCount do
;            SOpChan = sprintf("%s%d", SPartParentKey, iOCount)
;            iOpParent[] = makeParentContainer(iBB, SOpChan, SPartParentKey)
;            iCount = 0
;            while iCount < iLen do
;                SParamKey = sprintf("%s%d%s", SPartParentKey, iOCount, SParamText[iCount])
;                prints("%s %s %s %s\n", SPartKey, SPartParentKey, SOpChan, SParamKey)
;                iKnobBB[] = getrow(iKnobInsetBBoxes, iCount)
;                printarray(iKnobBB)
;                x_create "image", fillarray(\
;                    x_bounds(getrow(iKnobInsetBBoxes, iCount)),\
;                    x_parent(SOpChan),\
;                    SKnobInsetColours[iCount],\
;                    x_corners(16))

;                iKnobBB[] = getrow(iLabelBBoxes, iCount)
;                printarray(iKnobBB)
;                x_create "label", fillarray(\
;                    x_bounds(getrow(iLabelBBoxes, iCount)),\
;                    x_channel(sprintf("%s%slab", SOpChan, SLabelText[iCount])),\
;                    x_parent(SOpChan),\
;                    x_align(SLabelAlign[iCount]),\
;                    x_text(SLabelText[iCount]))

;                iKnobBB[] = getrow(iKnobBBoxes, iCount)
;                printarray(iKnobBB)
;                x_create "rslider", fillarray(\
;                    x__tag("obj", SPartKey),\
;                    x_bounds(getrow(iKnobBBoxes, iCount)),\
;                    x_channel(sprintf("%s%s", SOpChan, SParamText[iCount])),\
;                    x_parent(SOpChan),\
;                    SRanges[iCount])

;                iCount += 1
;            od
;            iOCount += 1
;        od
;        iPCount += 1
;    od
endop

opcode makeParts, 0, i[]Siiii
    iBB[], SParent, iPartCount, iOperatorCount, iKnobSize, iLabelSize xin

    iVerticalPadding = 3
    iComponentSections = 3
    iSelectButtonSize = 8

    iLabelTrim = iLabelSize + (iVerticalPadding * 2)

    iBBoxes[][] bb_split iBB, iComponentSections, "v"

    iPartBB[] = getrow(iBBoxes, 0)
    iPartLabelBB[] = bb_inside(iPartBB, 0, iLabelTrim, "lt")
    iPartBB[] = bb_trim(iPartBB, "y", iLabelTrim)

    iOpBB[] = getrow(iBBoxes, 1)
    iOpLabelBB[] = bb_inside(iOpBB, 0, iLabelTrim, "lt")
    iOpBB[] = bb_trim(iOpBB, "y", iLabelTrim)

    iEnvBB[] = getrow(iBBoxes, 2)
    iEnvLabelBB[] = bb_inside(iEnvBB, 0, iLabelTrim, "lt")
    iEnvBB[] = bb_trim(iEnvBB, "y", iLabelTrim)

;    x_img x_bounds(iPartLabelBB), x_colour(255, 255, 0, 60), x_parent(SParent)
;    x_img x_bounds(iPartBB), x_colour(255, 0, 0, 60), x_parent(SParent)
;    x_img x_bounds(iOpLabelBB), x_colour(255, 255, 0, 120), x_parent(SParent)
;    x_img x_bounds(iOpBB), x_colour(255, 0, 0, 120), x_parent(SParent)
;    x_img x_bounds(iEnvLabelBB), x_colour(255, 255, 0, 180), x_parent(SParent)
;    x_img x_bounds(iEnvBB), x_colour(255, 0, 0, 180), x_parent(SParent)

    SPartLabel = sprintf("%slab", SParent)
    makePartLabel(makeParentContainer(iPartLabelBB, SPartLabel, SParent), SPartLabel, SParent, iPartCount, iKnobSize, iLabelSize, iSelectButtonSize)

    SPartGlob = sprintf("%sglob", SParent)
    makePartGlobal(makeParentContainer(iPartBB, SPartGlob, SParent), SPartGlob, SParent, iPartCount, iKnobSize, iLabelSize)

    SEnvLabel = sprintf("%spatch", SParent)
    makePatchSets(makeParentContainer(iEnvLabelBB, SEnvLabel, SParent), SEnvLabel, SParent, iLabelSize)

    SOpLabel = sprintf("%soplab", SParent)
    makeOpLabel(makeParentContainer(iOpLabelBB, SOpLabel, SParent), SOpLabel, SParent, iPartCount, iOperatorCount, iKnobSize, iLabelSize, iSelectButtonSize)

    SPartOp = sprintf("%sop", SParent)
    makeOsc(makeParentContainer(iOpBB, SPartOp, SParent), SPartOp, SParent, iPartCount, iOperatorCount, iKnobSize, iLabelSize, iLabelTrim, iSelectButtonSize)

    SPartEnv = sprintf("%senv", SParent)
    makeEnvelope2(makeParentContainer(iEnvBB, SPartEnv, SParent), SPartEnv, SParent, iPartCount, iOperatorCount, iKnobSize, iLabelSize, iLabelTrim)
endop

opcode stringArrayToCode, 0, SS[]
    SSet, SStrs[] xin
    prints("%s = fillarray(\\\n", SSet)
    iLen = lenarray(SStrs)
    iCount = 0
    while iCount < iLen do
        if iCount < (iLen - 1) then
            prints("\t\"%s\",\\\n", SStrs[iCount])
        else
            prints("\t\"%s\")\n", SStrs[iCount])
        endif
        iCount += 1
    od
endop

instr builder
    iW cabbageGet "form", "width"
    iH cabbageGet "form", "height"

    iBB[] = bb_base(iW, iH)

    x_flattenCode(0)

    SParent = "part"
    makeParts(makeParentContainer(iBB, SParent), SParent, giMaxParts, giMaxOps, 30, 18)

    gSPart0Keys[] cabbageGetWidgetChannels "_obj(\"part0\")"
    gSPart1Keys[] cabbageGetWidgetChannels "_obj(\"part1\")"
    gSPart2Keys[] cabbageGetWidgetChannels "_obj(\"part2\")"
    gSPart3Keys[] cabbageGetWidgetChannels "_obj(\"part3\")"

;    stringArrayToCode("gSPart0Keys", gSPart0Keys)
;    stringArrayToCode("gSPart1Keys", gSPart1Keys)
;    stringArrayToCode("gSPart2Keys", gSPart2Keys)
;    stringArrayToCode("gSPart3Keys", gSPart3Keys)
/*
    gSPart0Keys[] cabbageGetWidgetChannels sprintf("_obj(\"%s0\")", SParent)
    gSPart1Keys[] cabbageGetWidgetChannels sprintf("_obj(\"%s1\")", SParent)
    gSPart2Keys[] cabbageGetWidgetChannels sprintf("_obj(\"%s2\")", SParent)
    gSPart3Keys[] cabbageGetWidgetChannels sprintf("_obj(\"%s3\")", SParent)
*/

    ; set up interface
    cabbageSetValue "part0sel", 1
    cabbageSetValue "partcmd", 1

    iPartCount = 0
    while iPartCount < giMaxParts do
        cabbageSetValue sprintf("part%dop0sel", iPartCount), 1
        cabbageSetValue sprintf("part%dpat", iPartCount), 1
        cabbageSetValue sprintf("part%dsrc", iPartCount), 1
        cabbageSetValue sprintf("part%dscl", iPartCount), 7 ; this should select 12et
        cabbageSetValue sprintf("part%dalg", iPartCount), 1

        cabbageSetValue sprintf("part%dop0sel", iPartCount), 1

        iOpCount = 0
        while iOpCount < giMaxOps do
            cabbageSetValue sprintf("part%dop%dwv", iPartCount, iOpCount), 1

            iOpCount += 1
        od
        iPartCount += 1
    od

;    iLen = lenarray(gSPart0Keys)
;    iCount = 0
;    prints("lenarray(%d)\n", iLen)
;    while iCount < iLen do
;        prints("[%d] %s %s %s %s\n", iCount, gSPart0Keys[iCount], gSPart1Keys[iCount], gSPart2Keys[iCount], gSPart3Keys[iCount])
;        iCount += 1
;    od
endin
