opcode displayString, S, kkkk
    kRatioFixed, kOctave, kStep, kCent xin
    SDisplay = ""
    kCalcCent = (kOctave * 1200) + (kStep * 100) + kCent
    if kRatioFixed == 0 then ; ratio
        SDisplay = sprintfk("%4.2f Cent", kCalcCent)
    else ; fixed
        SDisplay = sprintfk("%4.2f Hz", 55 * cent(kCalcCent))
    endif
    xout SDisplay
endop

opcode process4PitchDisplay, 0, k[]S[]
    kData[], SKeys[] xin
    if changed(kData[0], kData[1], kData[2], kData[3]) == 1 then
        cabbageSet k(1), SKeys[0], "text", displayString(kData[0], kData[1], kData[2], kData[3])
    elseif changed(kData[4], kData[5], kData[6], kData[7]) == 1 then
        cabbageSet k(1), SKeys[1], "text", displayString(kData[4], kData[5], kData[6], kData[7])
    elseif changed(kData[8], kData[9], kData[10], kData[11]) == 1 then
        cabbageSet k(1), SKeys[2], "text", displayString(kData[8], kData[9], kData[10], kData[11])
    elseif changed(kData[12], kData[13], kData[14], kData[15]) == 1 then
        cabbageSet k(1), SKeys[3], "text", displayString(kData[12], kData[13], kData[14], kData[15])
    endif
endop

instr freq4helper
    kIndex init 0
    SPart0Keys[] fillarray "part0op0md", "part0op0octave", "part0op0step", "part0op0cent",\
                           "part0op1md", "part0op1octave", "part0op1step", "part0op1cent",\
                           "part0op2md", "part0op2octave", "part0op2step", "part0op2cent",\
                           "part0op3md", "part0op3octave", "part0op3step", "part0op3cent"
    SPart1Keys[] fillarray "part1op0md", "part1op0octave", "part1op0step", "part1op0cent",\
                           "part1op1md", "part1op1octave", "part1op1step", "part1op1cent",\
                           "part1op2md", "part1op2octave", "part1op2step", "part1op2cent",\
                           "part1op3md", "part1op3octave", "part1op3step", "part1op3cent"
    SPart2Keys[] fillarray "part2op0md", "part2op0octave", "part2op0step", "part2op0cent",\
                           "part2op1md", "part2op1octave", "part2op1step", "part2op1cent",\
                           "part2op2md", "part2op2octave", "part2op2step", "part2op2cent",\
                           "part2op3md", "part2op3octave", "part2op3step", "part2op3cent"
    SPart3Keys[] fillarray "part3op0md", "part3op0octave", "part3op0step", "part3op0cent",\
                           "part3op1md", "part3op1octave", "part3op1step", "part3op1cent",\
                           "part3op2md", "part3op2octave", "part3op2step", "part3op2cent",\
                           "part3op3md", "part3op3octave", "part3op3step", "part3op3cent"

    SPart0Display[] fillarray "part0op0pitchdisplay", "part0op1pitchdisplay", "part0op2pitchdisplay", "part0op3pitchdisplay"
    SPart1Display[] fillarray "part1op0pitchdisplay", "part1op1pitchdisplay", "part1op2pitchdisplay", "part1op3pitchdisplay"
    SPart2Display[] fillarray "part2op0pitchdisplay", "part2op1pitchdisplay", "part2op2pitchdisplay", "part2op3pitchdisplay"
    SPart3Display[] fillarray "part3op0pitchdisplay", "part3op1pitchdisplay", "part3op2pitchdisplay", "part3op3pitchdisplay"

    if kIndex == 0 then
        process4PitchDisplay(cabbageGetValue(SPart0Keys), SPart0Display)

    elseif kIndex == 2 then
        process4PitchDisplay(cabbageGetValue(SPart1Keys), SPart1Display)

    elseif kIndex == 4 then
        process4PitchDisplay(cabbageGetValue(SPart2Keys), SPart2Display)

    elseif kIndex == 6 then
        process4PitchDisplay(cabbageGetValue(SPart3Keys), SPart3Display)

        kIndex = -2
    endif
    kIndex += 1
endin

opcode buttonFlag, k, k[]
    kFlags[] xin
    kLen = lenarray:k(kFlags)
    kCount = 0
    kVal = -1
    while kVal < 0 && kCount < kLen do
        if kFlags[kCount] == 1 then
            kVal = kCount
        endif
        kCount += 1
    od
    xout kVal
endop

opcode visibleOperators, 0, kS[]
    kOpCount, SKeys[] xin
    kCount = 0
    kVal = 0
    while kCount < giMaxOps do
        if kCount < kOpCount then
            kVal = 1
        else
            kVal = 0
        endif
        cabbageSet k(1), SKeys[kCount], "visible", kVal
        kCount += 1
    od
endop

; this assumes both arrays are of the same size
opcode visiblePlant, 0, S[]k[]
    SKeys[], kValues[] xin
    kLen = lenarray:k(SKeys)
    kCount = 0
    while kCount < kLen do
        cabbageSet k(1), SKeys[kCount], "visible", kValues[kCount]
        kCount += 1
    od
endop

instr gui4helper
/*
    iColours[][] init 3, 4
    iColours[][] = fillarray(255, 0, 127,    127, 127, 255,    0, 255, 127,    127, 127, 0)
    */
    kCurrentFlag init 0
    kCurrentPart init -1
    kCurrentOps[] = fillarray(-1, -1, -1, -1)
    SPartLabelKeys[] = fillarray("part0", "part1", "part2", "part3")
    SPartLabelPlants[] = fillarray("part0lab", "part1lab", "part2lab", "part3lab")
    SPartGlobPlants[] = fillarray("part0glob", "part1glob", "part2glob", "part3glob")
    SPartOpLabelPlants[] = fillarray("part0oplab", "part1oplab", "part2oplab", "part3oplab")
    SPartOpPlants[] = fillarray("part0op", "part1op", "part2op", "part3op")
    SPartEnvPlants[] = fillarray("part0env", "part1env", "part2env", "part3env")
;    SPartFiltPlants[] = fillarray("part0filt", "part1filt", "part2filt", "part3filt")
    SQrtObjSelect[] = fillarray("part0sel", "part1sel", "part2sel", "part3sel")

    SUnderlayWidgets[] = fillarray("partpitchul", "partphaseul", "partsenseul", "partbpointul", "partenvlul", "partenvrul")

    SPartSave[] = fillarray("part0sav", "part1sav", "part2sav", "part3sav")
    SInputSrcs[] = fillarray("part0src", "part1src", "part2src", "part3src")

    ; part select
    kVal[] cabbageGetValue SQrtObjSelect
    if changed(kVal[0], kVal[1], kVal[2], kVal[3]) == 1 then
        kCurrentFlag = 1
        kCurrentPart = buttonFlag(kVal)
;        printsk "chan: %d %d %d %d kV: %d\n", kVal[0], kVal[1], kVal[2], kVal[3], kCurrentPart
;        printsk "ops: %d %d %d %d\n", kCurrentOps[0], kCurrentOps[1], kCurrentOps[2], kCurrentOps[3]
        cabbageSet k(1), "partlabX", "text", SPartLabelKeys[kCurrentPart]
        visiblePlant(SPartLabelPlants, kVal)
        visiblePlant(SPartGlobPlants, kVal)
        visiblePlant(SPartOpLabelPlants, kVal)
        visiblePlant(SPartOpPlants, kVal)
        visiblePlant(SPartEnvPlants, kVal)
    endif

    ; operator select
    SOpLabelKeys[] = fillarray("op0", "op1", "op2", "op3")
    SPart0Keys[] = fillarray("part0op0sel", "part0op1sel", "part0op2sel", "part0op3sel")
    SPart0OpsPlants[] = fillarray("part0op0", "part0op1", "part0op2", "part0op3")
    SPart0EnvPlants[] = fillarray("part0env0", "part0env1", "part0env2", "part0env3")
    kPart0[] cabbageGetValue SPart0Keys
    if changed(kPart0[0], kPart0[1], kPart0[2], kPart0[3]) == 1 then
        kCurrentFlag = 1
        kCurrentOps[0] = buttonFlag(kPart0)
;        printsk "chan: %d %d %d %d kV: %d\n", kPart0[0], kPart0[1], kPart0[2], kPart0[3], kCurrentOps[0]
        cabbageSet k(1), "part0oplabX", "text", SOpLabelKeys[kCurrentOps[0]]
        visiblePlant(SPart0OpsPlants, kPart0)
        visiblePlant(SPart0EnvPlants, kPart0)
    endif
    SPart1Keys[] = fillarray("part1op0sel", "part1op1sel", "part1op2sel", "part1op3sel")
    SPart1OpsPlants[] = fillarray("part1op0", "part1op1", "part1op2", "part1op3")
    SPart1EnvPlants[] = fillarray("part1env0", "part1env1", "part1env2", "part1env3")
    kPart1[] cabbageGetValue SPart1Keys
    if changed(kPart1[0], kPart1[1], kPart1[2], kPart1[3]) == 1 then
        kCurrentFlag = 1
        kCurrentOps[1] = buttonFlag(kPart1)
        cabbageSet k(1), "part1oplabX", "text", SOpLabelKeys[kCurrentOps[1]]
        visiblePlant(SPart1OpsPlants, kPart1)
        visiblePlant(SPart1EnvPlants, kPart1)
    endif
    SPart2Keys[] = fillarray("part2op0sel", "part2op1sel", "part2op2sel", "part2op3sel")
    SPart2OpsPlants[] = fillarray("part2op0", "part2op1", "part2op2", "part2op3")
    SPart2EnvPlants[] = fillarray("part2env0", "part2env1", "part2env2", "part2env3")
    kPart2[] cabbageGetValue SPart2Keys
    if changed(kPart2[0], kPart2[1], kPart2[2], kPart2[3]) == 1 then
        kCurrentFlag = 1
        kCurrentOps[2] = buttonFlag(kPart2)
        cabbageSet k(1), "part2oplabX", "text", SOpLabelKeys[kCurrentOps[2]]
        visiblePlant(SPart2OpsPlants, kPart2)
        visiblePlant(SPart2EnvPlants, kPart2)
    endif
    SPart3Keys[] = fillarray("part3op0sel", "part3op1sel", "part3op2sel", "part3op3sel")
    SPart3OpsPlants[] = fillarray("part3op0", "part3op1", "part3op2", "part3op3")
    SPart3EnvPlants[] = fillarray("part3env0", "part3env1", "part3env2", "part3env3")
    kPart3[] cabbageGetValue SPart3Keys
    if changed(kPart3[0], kPart3[1], kPart3[2], kPart3[3]) == 1 then
        kCurrentFlag = 1
        kCurrentOps[3] = buttonFlag(kPart3)
        cabbageSet k(1), "part3oplabX", "text", SOpLabelKeys[kCurrentOps[3]]
        visiblePlant(SPart3OpsPlants, kPart3)
        visiblePlant(SPart3EnvPlants, kPart3)
    endif

    if kCurrentFlag == 1 then
    ; if changed(kCurrentPart, kCurrentOps[0], kCurrentOps[1], kCurrentOps[2], kCurrentOps[3]) == 1 then
        printsk("changing colors\n")
/*
        kLen = lenarray:k(SUnderlayWidgets)
        kCount = 0
        while kCount < kLen do
            kInColour[] = getrow(iColours, kCurrentPart)
            kColours[] = fillarray(kInColour[0], kInColour[1], kInColour[2], (kCurrentOps[kCurrentPart] * 50) + 50)
            cabbageSet SUnderlayWidgets[kCount], "colour", kColours[0], kColours[1], kColours[2], kColours[3]
        od
        */
        kCurrentFlag = 0
    endif

    iAlgorithmOperators[] = fillarray(0, 1,\
                2, 2, 2,\
                3, 3, 3, 3, 3, 3, 3, 3, 3, 3,\
                4, 4, 4, 4, 4, 4, 4, 4)
    SAlgorithmSelect[] = fillarray("part0alg", "part1alg", "part2alg", "part3alg")
    kAlgSelect[] cabbageGetValue SAlgorithmSelect
    ; operator select enabler
    if changed(kAlgSelect[0], kAlgSelect[1], kAlgSelect[2], kAlgSelect[3]) == 1 then
        if changed(kAlgSelect[0]) == 1 then
            visibleOperators(iAlgorithmOperators[kAlgSelect[0]], SPart0Keys)
            ; the last part is used when creating a unique instr number (dot format)
            gkPartAlgorithm[0] = kAlgSelect[0] + giAlgorithmOffset + 0.1
        endif
        if changed(kAlgSelect[1]) == 1 then
            visibleOperators(iAlgorithmOperators[kAlgSelect[1]], SPart1Keys)
            gkPartAlgorithm[1] = kAlgSelect[1] + giAlgorithmOffset + 0.2
        endif
        if changed(kAlgSelect[2]) == 1 then
            visibleOperators(iAlgorithmOperators[kAlgSelect[2]], SPart2Keys)
            gkPartAlgorithm[2] = kAlgSelect[2] + giAlgorithmOffset + 0.3
        endif
        if changed(kAlgSelect[3]) == 1 then
            visibleOperators(iAlgorithmOperators[kAlgSelect[3]], SPart3Keys)
            gkPartAlgorithm[3] = kAlgSelect[3] + giAlgorithmOffset + 0.4
        endif
    endif

    kSave[] cabbageGetValue SPartSave
    if changed(kSave[0], kSave[1], kSave[2], kSave[3]) == 1 then
        printsk "save: %d %d %d %d\n", kSave[0], kSave[1], kSave[2], kSave[3]
        if kSave[0] == 0 && changed(kSave[0]) == 1 then
            printsk "save[0]: %d\n", kSave[0]
        elseif kSave[1] == 0 && changed(kSave[1]) == 1 then
            printsk "save[1]: %d\n", kSave[1]
        elseif kSave[2] == 0 && changed(kSave[2]) == 1 then
            printsk "save[2]: %d\n", kSave[2]
        elseif kSave[3] == 0 && changed(kSave[3]) == 1 then
            printsk "save[3]: %d\n", kSave[3]
        endif
    endif

    kInputSrcs[] cabbageGetValue SInputSrcs
    if changed(kInputSrcs[0], kInputSrcs[1], kInputSrcs[2], kInputSrcs[3]) == 1 then
        printsk "source: %d %d %d %d\n", kInputSrcs[0], kInputSrcs[1], kInputSrcs[2], kInputSrcs[3]
        if changed(kInputSrcs[0]) == 1 then
            gkPartMidiChannel[0] = kInputSrcs[0]
        endif
        if changed(kInputSrcs[1]) == 1 then
            gkPartMidiChannel[1] = kInputSrcs[1]
        endif
        if changed(kInputSrcs[2]) == 1 then
            gkPartMidiChannel[2] = kInputSrcs[2]
        endif
        if changed(kInputSrcs[3]) == 1 then
            gkPartMidiChannel[3] = kInputSrcs[3]
        endif
    endif

    kCmd cabbageGetValue "partcmd"
    if changed(kCmd) == 1 then
        printsk "cmd: %d\n", kCmd
        if kCmd == 1 then
            ; do nothing
            ; printsk "cmd[%d] do nothing\n", kCmd
        else
            if kCmd == 2 then ; save
                printsk "cmd[%d] save\n", kCmd
            elseif kCmd == 3 then ; load
                printsk "cmd[%d]: load\n", kCmd
            elseif kCmd == 4 then ; import
                printsk "cmd[%d]: import\n", kCmd
            endif
            cabbageSetValue "partcmd", k(1)
        endif
    endif
endin
