; the instrument numbers are calculated by
; 1. when the user selects a new midi channel for a part,
;   a) take the index returned from the combobox
;   b) add the giAlgorithmOffset
;   c)
instr midihandler
    kstatus, kchan, kdata1, kdata2 midiin
    if kstatus == 0 then
        ; do nothing
    elseif kstatus == 128 then
        ; note off
        printks("off status: %d chan: %d data1: %d data2: %d\n", 0, kstatus, kchan, kdata1, kdata2)
        kPart = 0
        while kPart < giMaxParts do
            if kchan == gkPartMidiChannel[kPart] then
                turnoff2 gkPartAlgorithm[kPart] + (kdata1 * 0.0001), 4, 1
            endif
            kPart += 1
        od
    elseif kstatus == 144 then
        ; note on
        printks("on status: %d chan: %d data1: %d data2: %d\n", 0, kstatus, kchan, kdata1, kdata2)
        ; if velocity(kdata2) is 0, then this is a noteoff event
        if kdata2 == 0 then
            ; note off
            kPart = 0
            while kPart < giMaxParts do
                if kchan == gkPartMidiChannel[kPart] then
                    turnoff2 gkPartAlgorithm[kPart] + (kdata1 * 0.0001), 4, 1
                endif
                kPart += 1
            od
        else
            ; note on
            kPart = 0
            while kPart < giMaxParts do
                if kchan == gkPartMidiChannel[kPart] then
                    schedulek gkPartAlgorithm[kPart] + (kdata1 * 0.0001), 0, -1, kPart, kstatus, kchan, kdata1, kdata2
                endif
                kPart += 1
            od

        endif
    elseif kstatus == 160 then
        ; poly aftertouch
        printks("pat status: %d chan: %d data1: %d data2: %d\n", 0, kstatus, kchan, kdata1, kdata2)
    elseif kstatus == 176 then
        ; control change
        printks("cc status: %d chan: %d data1: %d data2: %d\n", 0, kstatus, kchan, kdata1, kdata2)
    elseif kstatus == 192 then
        ; program change
        printks("pc status: %d chan: %d data1: %d data2: %d\n", 0, kstatus, kchan, kdata1, kdata2)
    elseif kstatus == 208 then
        ; channel aftertouch
        printks("cat status: %d chan: %d data1: %d data2: %d\n", 0, kstatus, kchan, kdata1, kdata2)
    elseif kstatus == 224 then
        ; pitch bend
        printks("pb status: %d chan: %d data1: %d data2: %d\n", 0, kstatus, kchan, kdata1, kdata2)
    endif
endin
