#ifndef X_CREATOR_CSDX
#define X_CREATOR_CSDX #1#

/*
As each widget can have it's own set of appearances, x_ maintains a default library,
and a simple means to change those things as needed.
 */


gix_FlattenCode = 0
gix_toConsole = 0
gSx_OutFilename init ""
giOutFileHandle = -1

opcode x_flattenCode, 0, i
    iVal xin
    gix_FlattenCode = iVal
    gix_toConsole = 1
endop

opcode x_strparam, S, SS
    SKey, SData xin
    xout sprintf("%s(%s)", SKey, SData)
endop

opcode x_quote, S, S
    SData xin
    xout sprintf("\"%s\"", SData)
endop

opcode x_arrayCat, S, S[]oo
    SIdentifiers[], iWithQuotes, iWithComma xin
    iIndex = 0
    iLen lenarray SIdentifiers
    SText = ""
    if iWithComma == 0 then
        SSep = " "
    else
        SSep = ", "
    endif
    while iIndex < iLen do
		if iWithQuotes == 0 then
        	SText = strcat(SText, SIdentifiers[iIndex])
		else
			SText = strcat(SText, x_quote(SIdentifiers[iIndex]))
		endif
        iIndex = iIndex + 1
        if iIndex < iLen then
            SText = strcat(SText, SSep)
        endif
    od
    xout SText
endop

opcode x__tag, S, SS
    STag, SData xin
    xout sprintf("_%s(%s)", STag, SData)
endop

opcode x__tag, S, Si
    STag, iData xin
    xout sprintf("_%s(%d)", STag, iData)
endop

opcode x__tag, S, S
    STag xin
    xout x__tag(STag, 1)
endop

opcode x_create, 0, SS
    SWidgetType, SText xin
    if gix_FlattenCode == 1 then
        if gix_toConsole == 1 then
            prints "%s %s\n", SWidgetType, SText
        else
            
        endif
    endif
    cabbageCreate SWidgetType, SText
endop

/*
these three opcodes do all the finished work.
*/
opcode x_create, 0, SS[]
    SWidgetType, SIdentifiers[] xin
    SText = x_arrayCat(SIdentifiers)
    x_create SWidgetType, SText
endop

/*
SWidgetType is the string used to identify the widget type in Cabbage.
SIdentifiers are the list of identifiers for this specific widget, they
will override any of the identifiers in the defaults.
*/
opcode x_create, 0, SS[]S[]
    SWidgetType, SIdentifiers[], SDefaults[] xin
    SText = sprintf("%s %s", x_arrayCat(SDefaults), x_arrayCat(SIdentifiers))
    x_create SWidgetType, SText
endop

opcode x_create, 0, SS[]S[]S[]
    SWidgetType, SIdentifiers[], SDefaults[], SOverrides[] xin
    SText = sprintf("%s %s %s", x_arrayCat(SDefaults), x_arrayCat(SOverrides), x_arrayCat(SIdentifiers))
    x_create SWidgetType, SText
endop

opcode x_createWithTag, 0, SSS[]S[]S[]
    STag, SWidgetType, SIdentifiers[], SDefaults[], SOverrides[] xin
    SText = sprintf("_tag(\"%s\") %s %s %s", STag, x_arrayCat(SDefaults), x_arrayCat(SOverrides), x_arrayCat(SIdentifiers))
    x_create SWidgetType, SText
endop

opcode x_createWithTag, 0, SSS[]S[]
    STag, SWidgetType, SIdentifiers[], SDefaults[] xin
    SEmpty[] = fillarray("")
    x_createWithTag(STag, SWidgetType, SIdentifiers, SEmpty, SEmpty)
endop

opcode x_createWithTag, 0, SSS[]
    STag, SWidgetType, SIdentifiers[] xin
    SEmpty[] = fillarray("")
    x_createWithTag(STag, SWidgetType, SIdentifiers, SEmpty, SEmpty)
endop

/******
 ****** opcodes for identifiers
 ******/
opcode x_active, S, i
    iV xin
    xout sprintf("active(%d)", iV)
endop

opcode x_align, S, S
    SVal xin
    SText[] fillarray "left", "right", "centre", "top"
    iFlag = 0
    iLen = lenarray(SText)
    iCount = 0
    while iCount < iLen && iFlag == 0 do
        if strcmp(SText[iCount], SVal) == 0 then
            iFlag = 1
        endif
        iCount = iCount + 1
    od
    if iFlag == 0 then
        prints "x_: incorrect data passed to align. (%s)\n", SVal
    endif
    xout sprintf("align(%s)", x_quote(SVal))
endop

opcode x_alpha, S, i
    iV xin
    xout sprintf("alpha(%f)", iV)
endop

opcode x_ampRange, S, iiii
    iMin, iMax, iTabNum, iQuant xin
    xout sprintf("ampRange(%f, %f, %d, %f)", iMin, iMax, iTabNum, iQuant)
endop

opcode x_arrowBackgroundColour, S, S
    SVal xin
    xout sprintf("arrowBackgroundColour(%s)", x_quote(SVal))
endop

opcode x_arrowBackgroundColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("arrowBackgroundColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("arrowBackgroundColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_arrowColour, S, S
    SVal xin
    xout sprintf("arrowColour(%s)", x_quote(SVal))
endop

opcode x_arrowColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("arrowColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("arrowColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_automatable, S, i
    iV xin
    xout sprintf("automatable(%d)", iV)
endop

opcode x_backgroundColour, S, S
    SVal xin
    xout sprintf("backgroundColour(%s)", x_quote(SVal))
endop

opcode x_backgroundColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("backgroundColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("backgroundColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_blackNoteColour, S, S
    SVal xin
    xout sprintf("blackNoteColour(%s)", x_quote(SVal))
endop

opcode x_blackNoteColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("blackNoteColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("blackNoteColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_bounds, S, iiii
    iX, iY, iW, iH xin
    xout sprintf("bounds(%f, %f, %f, %f)", iX, iY, iW, iH)
endop

opcode x_bounds, S, i[]
    iData[] xin
    xout x_bounds(iData[0], iData[1], iData[2], iData[3])
endop

opcode x_caption, S, S
    SVal xin
    xout sprintf("caption(%s)", x_quote(SVal))
endop

opcode x_caretColour, S, S
    SVal xin
    xout sprintf("caretColour(%s)", x_quote(SVal))
endop

opcode x_caretColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("caretColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("caretColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_channel, S, S
    SData xin
    xout x_strparam("channel", x_quote(SData))
endop

opcode x_channelType, S, S
    SData xin
    xout x_strparam("channelType", x_quote(SData))
endop

/* colour from a string */
opcode x_colour, S, S
    SVal xin
    xout sprintf("colour(%s)", x_quote(SVal))
endop

opcode x_colour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("colour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("colour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_colour, S, i[]
    iC[] xin
    iLen = lenarray(iC)
    if iLen == 3 then
        SStr x_colour iC[0], iC[1], iC[2]
    elseif iLen == 4 then
        SStr x_colour iC[0], iC[1], iC[2], iC[3]
    endif
    xout SStr
endop

opcode x_colour2, S, iS
    iC, SVal xin
    xout sprintf("colour:%d(%s)", iC, x_quote(SVal))
endop

opcode x_colour2, S, iiiij
    iC, iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("colour:%d(%d, %d, %d)", iC, iR, iG, iB)
    else
        SStr = sprintf("colour:%d(%d, %d, %d, %d)", iC, iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_corners, S, i
    iV xin
    xout sprintf("corners(%d)", iV)
endop

opcode x_crop, S, iiii
    iX, iY, iW, iH xin
    xout sprintf("crop(%d, %d, %d, %d)", iX, iY, iW, iH)
endop

opcode x_displayType, S, S
    SData xin
    xout x_strparam("displayType", x_quote(SData))
endop

opcode x_doubleClickTogglesEdit, S, i
    iV xin
    xout sprintf("doubleClickTogglesEdit(%d)", iV)
endop

opcode x_file, S, S
    SData xin
    xout x_strparam("file", x_quote(SData))
endop

opcode x_fill, S, i
    iV xin
    xout sprintf("fill(%d)", iV)
endop

;opcode x_filmstrip, S, Siii
;    SFName, iNumFrames, iRemoveA, iRemoveB xin
;    xout sprintf("filmstrip(%s, %d, %f, %f)", SFName, iNumFrames, iRemoveA, iRemoveB)
;endop

opcode x_filmstrip, S, SiS
    SFName, iNumFrames, SDirection xin
    xout sprintf("filmstrip(%s, %d, %s)", x_quote(SFName), iNumFrames, x_quote(SDirection))
endop

opcode x_fontColour, S, S
    SVal xin
    xout sprintf("fontColour(%s)", x_quote(SVal))
endop

opcode x_fontColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("fontColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("fontColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_fontColour2, S, iS
    iC, SVal xin
    xout sprintf("fontColour:%d(%s)", iC, x_quote(SVal))
endop

opcode x_fontColour2, S, iiiij
    iC, iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("fontColour:%d(%d, %d, %d)", iC, iR, iG, iB)
    else
        SStr = sprintf("fontColour:%d(%d, %d, %d, %d)", iC, iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_fontSize, S, i
    iS xin
    xout sprintf("fontSize(%d)", iS)
endop

opcode x_gapMarkers, S, i
    iV xin
    xout sprintf("gapMarkers(%d)", iV)
endop

opcode x_highlightColour, S, S
    SVal xin
    xout sprintf("highlightColour(%s)", x_quote(SVal))
endop

opcode x_highlightColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("highlightColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("highlightColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_imgFile, S, SS
    SType, SFile xin
    xout sprintf("imgFile(%s, %s)", x_quote(SType), x_quote(SFile))
endop

opcode x_increment, S, i
    iV xin
    xout sprintf("increment(%f)", iV)
endop

opcode x_items, S, S
    SItems xin
    xout sprintf("items(%s)", SItems)
endop

opcode x_items, S, S[]
    SItems[] xin
    SX init ""
    iLen lenarray SItems
    iCount = 0
    while iCount < iLen do
        SX strcat SX, x_quote(SItems[iCount])
        if iCount < (iLen - 1) then
            SX strcat SX, ", "
        endif
        iCount = iCount + 1
    od
    xout sprintf("items(%s)", SX)
endop

opcode x_items, S, iS
    iSub, SItems xin
    xout sprintf("items:%d(%s)", iSub, SItems)
endop

opcode x_items2, S, iS
    iSub, SItems xin
    xout sprintf("items:%d(%s)", iSub, SItems)
endop

opcode x_keysdowncolour, S, S
    SVal xin
    xout sprintf("keysdowncolour(%s)", x_quote(SVal))
endop

opcode x_keysdowncolour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("keysdowncolour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("keysdowncolour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_keyseperatorcolour, S, S
    SVal xin
    xout sprintf("keyseperatorcolour(%s)", x_quote(SVal))
endop

opcode x_keyseperatorcolour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("keyseperatorcolour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("keyseperatorcolour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_keyWidth, S, i
    iV xin
    xout sprintf("keyWidth(%d)", iV)
endop

opcode x_keypressBaseOctave, S, i
    iV xin
    xout sprintf("keypressBaseOctave(%d)", iV)
endop

opcode x_latched, S, i
    iV xin
    xout sprintf("latched(%d)", iV)
endop

opcode x_lineThickness, S, i
    iV xin
    xout sprintf("lineThickness(%d)", iV)
endop

opcode x_markerColour, S, S
    SVal xin
    xout sprintf("markerColour(%s)", x_quote(SVal))
endop

opcode x_markerColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("markerColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("markerColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_markerEnd, S, i
    iV xin
    xout sprintf("markerEnd(%d)", iV)
endop

opcode x_markerStart, S, i
    iV xin
    xout sprintf("markerStart(%d)", iV)
endop

opcode x_markerThickness, S, i
    iV xin
    xout sprintf("markerThickness(%d)", iV)
endop

opcode x_max, S, i
    iV xin
    xout sprintf("max(%d)", iV)
endop

opcode x_meterColour, S, S
    SVal xin
    xout sprintf("meterColour(%s)", x_quote(SVal))
endop

opcode x_meterColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("meterColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("meterColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_meterColour2, S, iS
    iC, SVal xin
    xout sprintf("meterColour:%d(%s)", iC, x_quote(SVal))
endop

opcode x_meterColour2, S, iiiij
    iC, iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("meterColour:%d(%d, %d, %d)", iC, iR, iG, iB)
    else
        SStr = sprintf("meterColour:%d(%d, %d, %d, %d)", iC, iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_middleC, S, i
    iV xin
    xout sprintf("middleC(%d)", iV)
endop

opcode x_min, S, i
    iV xin
    xout sprintf("min(%d)", iV)
endop

opcode x_mode, S, S
    SData xin
    xout x_strparam("mode", x_quote(SData))
endop

opcode x_mouseOverKeyColour, S, S
    SVal xin
    xout sprintf("mouseOverKeyColour(%s)", x_quote(SVal))
endop

opcode x_mouseOverKeyColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("mouseOverKeyColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("mouseOverKeyColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_mouseInteraction, S, i
    iV xin
    xout sprintf("mouseInteraction(%d)", iV)
endop

opcode x_numberOfClicks, S, i
    iV xin
    xout sprintf("numberOfClicks(%d)", iV)
endop

opcode x_outlineColour, S, S
    SVal xin
    xout sprintf("outlineColour(%s)", x_quote(SVal))
endop

opcode x_outlineColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("outlineColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("outlineColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_outlineThickness, S, i
    iV xin
    xout sprintf("outlineThickness(%d)", iV)
endop

opcode x_overlayColour, S, S
    SVal xin
    xout sprintf("overlayColour(%s)", x_quote(SVal))
endop

opcode x_overlayColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("overlayColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("overlayColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_parent, S, S
    SParent xin
    SOut = ""
    if strcmp(SParent, "") != 0 then
        SOut = sprintf("parent(%s)", x_quote(SParent))
    endif
    xout SOut
endop

opcode x_populate, S, SSj
    SType, SDir, iIgnoreVal xin
    if iIgnoreVal >= 0 then
        SStr = sprintf("populate(%s, %s, %d)", x_quote(SType), x_quote(SDir), iIgnoreVal)
    else
        SStr = sprintf("populate(%s, %s)", x_quote(SType), x_quote(SDir))
    endif
    xout SStr
endop

opcode x_popup, S, i
    iV xin
    xout sprintf("popup(%d)", iV)
endop

opcode x_popupPostfix, S, S
    SText xin
    xout sprintf("popupPostfix(%s)", x_quote(SText))
endop

opcode x_popupPrefix, S, S
    SText xin
    xout sprintf("popupPrefix(%s)", x_quote(SText))
endop

opcode x_popupText, S, S
    SText xin
    xout sprintf("popupText(%s)", x_quote(SText))
endop

opcode x_presetIgnore, S, i
    iP xin
    xout sprintf("presetIgnore(%d)", iP)
endop

opcode x_protectedItems, S, i
    iP xin
    xout sprintf("protectedItems(%d)", iP)
endop

opcode x_radioGroup, S, S
    SData xin
    xout x_strparam("radioGroup", x_quote(SData))
endop

;opcode x_range, S, iijjj
;    iMin, iMax, iVal, iSkew, iIncr xin
;    if iVal < iMin || iVal > iMax then
;    
;    endif

opcode x_range, S, iiiii
    iMin, iMax, iVal, iSkew, iIncr xin
    xout sprintf("range(%f, %f, %f, %f, %f)", iMin, iMax, iVal, iSkew, iIncr)
endop

;opcode x_range, S, i[]
;    iDat[] xin
;    iLen = lenarray(iDat)
;endop

opcode x_readonly, S, i
    iR xin
    xout sprintf("readonly(%d)", iR)
endop

opcode x_rotate, S, iii
    iRadians, iPivotx, iPivoty xin
    xout sprintf("rotate(%f, %f, %f)", iRadians, iPivotx, iPivoty)
endop

opcode x_rotateCentered, S, i[]i
    iBBox[], iAngle xin
    iDegree = 6.283185307179586 / 360
    
    iX = iBBox[2] / 2
    iY = iBBox[3] / 2
    iR = iDegree * iAngle
    
    xout x_rotate(iR, iX, iY)
endop

opcode x_sampleRange, S, ii
    iMin, iMax xin
    xout sprintf("sampleRange(%d, %d)", iMin, iMax)
endop

opcode x_scrollbars, S, i
    iR xin
    xout sprintf("scrollbars(%d)", iR)
endop

opcode x_scrubberPosition, S, i
    iR xin
    xout sprintf("scrubberPosition(%d)", iR)
endop

opcode x_shape, S, S
    SData xin
    xout x_strparam("shape", x_quote(SData))
endop

opcode x_showscrubber, S, i
    iR xin
    xout sprintf("showscrubber(%d)", iR)
endop

opcode x_signalVariable, S, S
    SData xin
    xout x_strparam("signalVariable", x_quote(SData))
endop

opcode x_sliderBounds, S, iiii
    iX, iY, iW, iH xin
    xout sprintf("sliderBounds(%d, %d, %d, %d)", iX, iY, iW, iH)
endop

opcode x_sliderBounds, S, i[]
    iBBox[] xin
    xout sprintf("sliderBounds(%d, %d, %d, %d)", iBBox[0], iBBox[1], iBBox[2], iBBox[3])
endop

opcode x_sort, S, i
    iR xin
    xout sprintf("sort(%d)", iR)
endop

opcode x_tableBackgroundColour, S, S
    SVal xin
    xout sprintf("tableBackgroundColour(%s)", x_quote(SVal))
endop

opcode x_tableBackgroundColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("tableBackgroundColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("tableBackgroundColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_tableColour, S, iS
    iC, SVal xin
    xout sprintf("tableColour:%d(%s)", iC, x_quote(SVal))
endop

opcode x_tableColour, S, iiiij
    iC, iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("tableColour:%d(%d, %d, %d)", iC, iR, iG, iB)
    else
        SStr = sprintf("tableColour:%d(%d, %d, %d, %d)", iC, iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_tableGridColour, S, S
    SVal xin
    xout sprintf("tableGridColour(%s)", x_quote(SVal))
endop

opcode x_tableGridColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("tableGridColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("tableGridColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_tableNumber, S, i
    iR xin
    xout sprintf("tableNumber(%d)", iR)
endop

opcode x_text, S, S
    SData xin
    xout x_strparam("text", x_quote(SData))
endop

opcode x_textBox, S, i
    iR xin
    xout sprintf("textBox(%d)", iR)
endop

opcode x_textBoxColour, S, S
    SVal xin
    xout sprintf("textBoxColour(%s)", x_quote(SVal))
endop

opcode x_textBoxColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("textBoxColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("textBoxColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_textBoxOutlineColour, S, S
    SVal xin
    xout sprintf("textBoxOutlineColour(%s)", x_quote(SVal))
endop

opcode x_textBoxOutlineColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("textBoxOutlineColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("textBoxOutlineColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_textColour, S, S
    SVal xin
    xout sprintf("textColour(%s)", x_quote(SVal))
endop

opcode x_textColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("textColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("textColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_trackerColour, S, S
    SVal xin
    xout sprintf("trackerColour(%s)", x_quote(SVal))
endop

opcode x_trackerColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("trackerColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("trackerColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_trackerInsideRadius, S, i
    iR xin
    xout sprintf("trackerInsideRadius(%f)", iR)
endop

opcode x_trackerOutsideRadius, S, i
    iR xin
    xout sprintf("trackerOutsideRadius(%f)", iR)
endop

opcode x_trackerCentre, S, i
    iV xin
    xout sprintf("trackerCentre(%f)", iV)
endop

opcode x_trackerEnd, S, i
    iV xin
    xout sprintf("trackerEnd(%f)", iV)
endop

opcode x_trackerStart, S, i
    iV xin
    xout sprintf("trackerStart(%f)", iV)
endop

opcode x_trackerThickness, S, i
    iR xin
    xout sprintf("trackerThickness(%f)", iR)
endop

opcode x_updateRate, S, i
    iR xin
    xout sprintf("updateRate(%f)", iR)
endop

opcode x_value, S, i
    iR xin
    xout sprintf("value(%f)", iR)
endop

opcode x_valuePostfix, S, S
    SData xin
    xout x_strparam("valuePostfix", x_quote(SData))
endop

opcode x_valuePrefix, S, S
    SData xin
    xout x_strparam("valuePrefix", x_quote(SData))
endop

opcode x_valueTextBox, S, i
    iR xin
    xout sprintf("valueTextBox(%d)", iR)
endop

opcode x_valueTextBoxBounds, S, iiii
    iX, iY, iW, iH xin
    xout sprintf("valueTextBoxBounds(%d, %d, %d, %d)", iX, iY, iW, iH)
endop

opcode x_velocity, S, i
    iR xin
    xout sprintf("velocity(%f)", iR)
endop

opcode x_visible, S, i
    iR xin
    xout sprintf("visible(%d)", iR)
endop

opcode x_whiteNoteColour, S, S
    SVal xin
    xout sprintf("whiteNoteColour(%s)", x_quote(SVal))
endop

opcode x_whiteNoteColour, S, iiij
    iR, iG, iB, iA xin
    SStr = ""
    if iA == -1 then
        SStr = sprintf("whiteNoteColour(%d, %d, %d)", iR, iG, iB)
    else
        SStr = sprintf("whiteNoteColour(%d, %d, %d, %d)", iR, iG, iB, iA)
    endif
    xout SStr
endop

opcode x_wrap, S, i
    iR xin
    xout sprintf("wrap(%d)", iR)
endop

opcode x_zoom, S, i
    iR xin
    xout sprintf("zoom(%f)", iR)
endop

;; opcode used to display a bounding box on the screen, a layout tool
opcode x_img, 0, SS
    SBBox, SColour xin
    x_create "image", fillarray(SBBox, SColour)
endop

opcode x_img, 0, SSS
    SBBox, SColour, SParent xin
    x_create "image", fillarray(SBBox, SColour, SParent)
endop

opcode x_img, 0, SSSS
    SBBox, SColour, SParent, SChannel xin
    x_create "image", fillarray(SBBox, SColour, SParent, SChannel)
endop

opcode x_finishBuild, 0, 0
    if gix_FlattenCode == 1 then
        ficlose giOutFileHandle
    endif
endop

/*
opcode x_finishBuild, S[], S
    SObjKey xin
    if gix_FlattenCode == 1 then
        ficlose giOutFileHandle
    endif
    xout cabbageGetWidgetChannels(x_strparam("_param", x_quote(SObjKey)))
endop
*/

gSNull[] fillarray ""

#end
